
#include<string.h>
#include<dos.h>
#include<stdlib.h>

#include<stdio.h>

#include"graphic.h"
#include<conio.h>

TFrame_Type Frame_Type[7]={
  {' ',' ',' ',' ',' ',' '},
  {'','','','','',''},
  {'','','','','',''},
  {'','','','','',''},
  {'','','','','',''},
  {'+','+','+','+','-','|'},
  {'','','','','',''}
};



//--------------------------- point ------------------------------------------
TPoint point (byte X, byte Y) {
  TPoint H;
  H.X = X;
  H.Y = Y;
  return (H);
}

//--------------------------- goto_xy  -----------------------------------------
void goto_xy (byte X, byte Y) {
  gotoxy (X+1,Y+1);
} /* goto_xy */

//--------------------------- color  -----------------------------------------
int color (int B1,int B2, int I1, int I2) {
  return (B1 + 16*B2 + 256*I1 + 4096*I2);
} /* color */

//--------------------------- attrib -----------------------------------------
int attrib (byte B, byte I) {
  return (16*B + I);
}


//--------------------------- plus -----------------------------------------
TPoint plus (TPoint A, TPoint B) {
  A.X+=B.X;
  A.Y+=B.Y;
  return (A);
}

//--------------------------- put_char  -----------------------------------------
void put_char (byte X, byte Y, char Z) {
  if (X<MAX_X && Y<MAX_Y){
    goto_xy (X,Y);
    _AH=0xA;  // Cislo fce
    _AL=Z;    // Zapisovany znak
    _CX=1;    // Pocet opakovani
    geninterrupt (0x10);
  }
} /* put_char */

//--------------------------- put_char_attr  -----------------------------------------
void put_char_attr (byte X, byte Y, char Z, byte Attr) {
  if (X<MAX_X && Y<MAX_Y){
    goto_xy (X,Y);
    _AH=9;    // Cislo fce
    _AL=Z;    // Zapisovany znak
    _CX=1;    // Pocet opakovani
    _BH=0;    // Cislo vidostranky
    _BL=Attr; // Atribut zapisovaneho znaku
    geninterrupt (0x10);
  }
} /* put_char_attr */

//--------------------------- get_char  -----------------------------------------
char get_char (byte X, byte Y) {
  if (X<MAX_X && Y<MAX_Y){
    goto_xy (X,Y);
    _AH=8;    // Cislo fce
    _BH=0;    // Cislo vidostranky
    geninterrupt (0x10);
    return (_AL);    // Nacteny znak
  }
  else
    return (0);
} /* get_char */


//--------------------------- get_char_attr -----------------------------------------
void get_char_attr (byte X, byte Y, char &Z, byte &Attr) {
  if (X<MAX_X && Y<MAX_Y){
    goto_xy (X,Y);
    _AH=8;    // Cislo fce
    _BH=0;    // Cislo vidostranky
    geninterrupt (0x10);
    Z=_AL;    // Nacteny znak
    Attr=_AH; // Atribut nacteneho znaku
  }
} /* get_char_attr */


//--------------------------- write_xy  -----------------------------------------
void write_xy (byte X, byte Y, string What) {
  if (What!=NULL){
    int N = strlen (What);

    for(int i=0; i<N; i++)
      put_char (X+i,Y,What[i]);
  }
} /* write_xy */

//--------------------------- set_cursor  -----------------------------------------
void set_cursor (byte Mod1, byte Mod2) {
  _AH=1;
  _CL=Mod1;
  _CH=Mod2;
  geninterrupt (0x10);
} /* set_cursor */

//--------------------------- save_cursor  -----------------------------------------
TCursor save_cursor () {
  TCursor Cur;
  _AH=3;
  _BH=0;
  geninterrupt (0x10);
  Cur.A.X=_DL;
  Cur.A.Y=_DH;
  Cur.Mod1=_CL;
  Cur.Mod2=_CH;
  return (Cur);
} /* save_cursor */

//--------------------------- restore_cursor  -----------------------------------------
void restore_cursor (TCursor Cur) {
  goto_xy (Cur.A.X, Cur.A.Y);
  set_cursor (Cur.Mod1,Cur.Mod2);
} /* restore_cursor */

//--------------------------- draw_rect --------------------------------------

void draw_rect (TPoint A, TPoint B, int Attr) {
  boolean RightBottom=FALSE;
  uint Width=B.X-A.X;
  uint Height=B.Y-A.Y;


  char Line[]="";
  if (B.Y==MAX_Y && B.X==MAX_X){
    Height--;
    RightBottom=TRUE;
  }
  for(uint i=0; i<Height; i++)
    print_xyla (A.X,A.Y+i,Width,Line,Attr);
  if (RightBottom){
    print_xyla (A.X,A.Y+i,Width-1,Line,Attr);
    put_char_attr (MAX_X-1,MAX_Y-1,'',Attr);
  }

}

//--------------------------- save_rect  -----------------------------------------
// Ulozi obsah obdelnika (A,B) do Bufferu, ktery je jiz naalokovan (a ma
// dostatecnou velikost.

void save_rect(TPoint A, TPoint B, PVideoBuffer Buffer) {
  int Count=0;
  byte Attr;
  char Z;
  TAttrCur AC=save_ac ();

  for (int i=A.X; i<B.X; i++)
    for(int j=A.Y; j<B.Y; j++) {
      get_char_attr (i,j,Z,Attr);  // nacte Znak+Attribut
      Buffer[Count]=(byte)Z;             // ulozi Znak
      Count++;
      Buffer[Count]=(byte)Attr;          // ulozi Attribut
      Count++;
    }
  restore_ac (AC);
} /* save_rect */

//--------------------------- restore_rect  -----------------------------------------
void restore_rect (TPoint A, TPoint B, PVideoBuffer Buffer) {
  int Count=0;
  TAttrCur AC=save_ac ();
  for (int i=A.X; i<B.X; i++)
    for(int j=A.Y; j<B.Y; j++) {
      put_char_attr (i,j,Buffer[Count], Buffer[Count+1]);
      Count+=2;
    }
  restore_ac (AC);
} /* restore_rect */


//--------------------------- draw_rect_shadow  -----------------------------------------
void draw_rect_shadow (TPoint A, TPoint B, int ShadowAttr) {
  TAttrCur AC=save_ac ();
  int i;
  for(i=A.X+1; i<=B.X; i++)   // Bottom
    put_char_attr (i,B.Y,SHADOW_BOTTOM_CHAR,ShadowAttr);
  for(i=A.Y+1; i<B.Y; i++)    // Right
    put_char_attr (B.X,i,SOLID_CHAR,ShadowAttr);
  put_char_attr (B.X,A.Y,SHADOW_TOP_CHAR,ShadowAttr);
  restore_ac (AC);
} /* draw_rect_shadow */


//--------------------------- draw_frame -----------------------------------------
void draw_frame (TPoint A,TPoint B,byte Type,string Label, byte B1, byte I1) {
  TAttrCur AC=save_ac ();
  int Attr=attrib (B1,I1);
  byte i;
  // vodorovne cary
  for(i=A.X; i<B.X-1; i++){
    put_char_attr (i,A.Y,Frame_Type[Type].Left, Attr);
    put_char_attr (i,B.Y-1,Frame_Type[Type].Left, Attr);
  }
  // svisle cary
  for(i=A.Y; i<B.Y-1; i++){
    put_char_attr (A.X,i,Frame_Type[Type].Top, Attr);
    put_char_attr (B.X-1,i,Frame_Type[Type].Top, Attr);
  }
  // rohy
  put_char_attr (A.X,A.Y,Frame_Type[Type].Left_Top,Attr);
  put_char_attr (B.X-1,A.Y,Frame_Type[Type].Right_Top,Attr);
  put_char_attr (B.X-1,B.Y-1,Frame_Type[Type].Right_Bottom,Attr);
  put_char_attr (A.X,B.Y-1,Frame_Type[Type].Left_Bottom,Attr);

  if (Label!=NULL && strlen (Label)>0){
    put_char (A.X+1,A.Y,' ');
    put_char (A.X+strlen (Label)+2,A.Y,' ');
    write_xy (A.X+2,A.Y,Label);
  }
  restore_ac (AC);
}
//--------------------------- background  -----------------------------------------
void background () {
  TAttrCur AC=save_ac ();
  int Attr =attrib (BLACK,LIGHTGRAY);
  for(int i=0; i<MAX_X; i++)
    for(int j=0; j<MAX_Y; j++)
      put_char_attr (i,j,random ('Z'-'A')+'A',Attr);

  restore_ac (AC);
} /* background */

//-------------------------- game_over  --------------------------------------
void game_over(string Message){
  textattr (attrib (BLACK,LIGHTGRAY));
  clrscr();
  printf ("\nERROR: %s",Message);
  exit(0);
}

//--------------------------- print_xyla  -----------------------------------------
void print_xyla (uint X, uint Y, uint Length, string Str, byte Attr) {
  TAttrCur AC=save_ac ();
  textattr (Attr);
  print_xyl (X, Y, Length, Str);
  restore_ac (AC);
} /* print_xyla */

//--------------------------- print_xyl  -----------------------------------------
void print_xyl (uint X, uint Y, uint Length, string Str) {
  uint i=0;
  uint N=0;
  TAttrCur AC=save_ac ();

  char DelLine[]="                                                                              ";
  //"";

  if (X<MAX_X && Y<MAX_Y){
    goto_xy (X,Y);

    if (Str!=NULL){
      N=strlen (Str);
      uint Pos=(Length<N)?Length:N; //min
      char Z=Str[Pos];
      Str[Pos]='\0';
      cprintf("%s",Str);
      Str[Pos]=Z;
      i=Pos;
    }
    if (i<Length){
      DelLine[Length-i]='\0';
      cprintf(DelLine);
    }
  }
  restore_ac (AC);
} /* print_xyl */

//--------------------------- save_ac  -----------------------------------------
TAttrCur save_ac () {
  struct text_info TI;
  gettextinfo(&TI);
  TAttrCur Pom;
  Pom.Attr=TI.attribute;
  Pom.Cur=save_cursor();
  set_cursor (CUR_OFF);
  return (Pom);
} /* save_ac */

//--------------------------- restore_ac  -----------------------------------------
void restore_ac (TAttrCur AC) {
  textattr (AC.Attr);
  restore_cursor (AC.Cur);
} /* restore_ac */

