#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include"string.h"

char Spaces[]="|=+-*/!?,;:\\.&(){}[]<>\" '#";

//--------------------------- new_str  -----------------------------------------
// naalokuje pamet pro novy retezec delky Length+1, znak [Length]='/0'
// a bude obsahovati pouze same mezery

string new_str (int Length) {
  string Pom=NULL;
  if (Length>=0){
    if ((Pom=(string)malloc(Length+1))==NULL)
      game_over ("Malo pameti (new_str)");
    for(uint i=0; i<Length; i++)
      Pom[i]=' ';
    Pom[Length]='\0';
  }
  return (Pom);
} /* new_str */

//--------------------------- new_str_cpy  --------------------------------------
// vytvori novou kopii stringu Str (samozrejme pro ni nejdrive naalokuje
// pamet)

string new_str_cpy (string Str) {
  string NewStr=NULL;
  if (Str!=NULL){
    NewStr=new_str (strlen (Str));
    strcpy (NewStr, Str);
  }
  return (NewStr);
} /* new_str_cpy */

//--------------------------- n_char  -----------------------------------------
// vraci string obsahujici N znaku Z
string n_char (int N, char Z) {
  string Pom=NULL;

  if (N>=0){
    Pom=new_str (N);
    strset (Pom,Z);
  }
  return (Pom);
} /* n_char */

//--------------------------- int_to_str  -----------------------------------------
// prevod integru (long) na string

string int_to_str (long Num) {
  long i=1;
  int N=1;
  byte Sign;
  string Pom;
  byte Cifra;

  if (Num<0) Sign=TRUE;   // Zjisteni znamenka
  else Sign=FALSE;

  Num=labs(Num);

  // Zjistime pocet cifer
  while ((Num/i)>=1){
    i=i*10;
    N++;
    }
  if (Num!=0) N--;

  N+=Sign;  // pripocte se misto na znamenko

  Pom=new_str(N);

  for(i=0; i<N-Sign; i++){
    Cifra = Num%10;
    Num=Num/10;

    Pom[N-i-1]='0'+ Cifra;

  }

  if (Sign) Pom[0]='-';       // prida se pripadne znamenko
  return (Pom);
} /* int_to_str */

//--------------------------- del_char  -----------------------------------------
string del_char (int Pos, string Str) {
  if (Pos>=0 && Str!=NULL && Pos<strlen (Str))
    strcpy (&Str[Pos],&Str[Pos+1]);

  return (Str);
} /* del_char */

//--------------------------- del_nlchar  -----------------------------------------
string del_nlchar (string Str) {

  if (Str!=NULL && Str[strlen(Str)-1]=='\n')
    Str[strlen(Str)-1]='\0';
  return (Str);
} /* del_nlchar */
//--------------------------- insert_char  -----------------------------------------
string insert_char (int Pos, char Z, string Str) {
// nekontroluje, zda pise za konec stringu!

  if (Pos>=0 && Str!=NULL){
    uint N=strlen (Str);
    int i;
    if (Pos>=N){   // pise za konec retezce-mezera se vyplni mezerama

      for(i=N; i<Pos; i++)
	Str[i]=' ';
      Str[Pos+1]='\0';  // vytvori '\0'
      Str[Pos]=Z;
    }
    else{          // pise doprostred retezce
      for(i=N+1; i>Pos; i--)
	Str[i]=Str[i-1];

      Str[Pos]=Z;
    }
  }
  return (Str);
} /* insert_char */
//--------------------------- new_str_insert_char  -----------------------------------------
string new_str_insert_char (int Pos, char Z, string Str) {
  string Str2=Str;
  if (Pos>=0){
    uint N=strlen (Str);
    if (Pos<N)
      Str2=new_str (N+1);
    else
      Str2=new_str (Pos+1);
    strcpy (Str2, Str);  // prekopirujem obsah a protoze mame retezec
			 // alokovan na spravnou velikost, zavolame fci
			 // insert_char
    free (Str);
    Str2=insert_char (Pos,Z,Str2);
  }
  return (Str2);
} /* new_str_insert_char */

//--------------------------- read_line  -----------------------------------------
int read_line (FILE *F, string &Line) {
  char Buffer[250];

  strset (Buffer,' ');
  if (fgets (Buffer,250,F)!=NULL){
    if ((Line=(string)malloc(strlen(Buffer)+1))==NULL)
      return (-1);
    else
      strcpy (Line,Buffer);
  }
  else
    Line=NULL;
  return (0);

} /* read_line */

//--------------------------- find_str  -----------------------------------------
int find_str (string What, string Where, uint Pos, boolean CS, boolean WW) {
// hleda retezec What v retezci Where, pokud jej nenalezne vrati hodnotu (-1)
  if (What!=NULL && Where!=NULL){
    uint LWhat=strlen (What);
    uint LWhere=strlen (Where);
    uint i=Pos;
    int Result=0;
      if (i<LWhere && LWhere>=LWhat){
	while (i<LWhere-LWhat+1){
	  if (CS)
	    Result=(strncmp (What, &Where[i],LWhat));
	  else
	    Result=(strncmpi (What, &Where[i],LWhat));
	  if (!Result){
	    // nejspise to nasel, staci zjistit, zda (pokud je zapnuta
	    // volba WholeWords jsou z obou stran oddelovaci znaky)

	    if ( !WW || (
		(i==0 ||
		  (i>0 && (strrchr (Spaces,Where[i-1])!=NULL)))&&
		(i==LWhere-1 ||
		  (i<LWhere-1 && (strrchr (Spaces,Where[i+LWhat]))))))
	    return (i);
	  }
	  i++;
	}
      }
    }
  return (-1);
} /* find_str */
//--------------------------- replace_str  -----------------------------------------
string replace_str (string What, string Where, uint Pos, int Length) {
// Tato fce se ad taktez pouzit na spojovani retezcu, pripadne vkladani
// jednoho retezce do druheho
  string Pom=Where;
  uint N=strlen (Where);
  uint N2=strlen (What);
  if (Pos<=N && Pos+Length<=N){
    Pom=new_str (N-Length+N2);
    strncpy (Pom,Where,Pos);
    strcpy (&Pom[Pos],What);
    strcpy (&Pom[Pos+N2],&Where[Pos+Length]);
    free (Where);
  }
  return (Pom);
} /* replace_str */
//--------------------------- next_word  -----------------------------------------
int next_word (string Where, uint Pos) {
  if (Where!=NULL && strlen (Where)>0){
    uint N=strlen (Where);
    uint i=Pos;
    if (Pos>=N-1)
      return (N-Pos-1);
    else {
      // Pos<N-1
      // najdeme nasledujici oddelovac nebo konec radky
      while (i<N-1 && strrchr (Spaces,Where[i])==NULL)
	i++;
      // a potom najdeme prvni pismenko
      while (i<N-1 && strrchr (Spaces,Where[i])!=NULL)
	i++;

      return (i-Pos);
    }
  }
  else return (0);
} /* next_word */
//--------------------------- prev_word  -----------------------------------------
int prev_word (string Where, uint Pos) {
  if (Where!=NULL && Pos>0 && strlen (Where)>0){
    uint i=Pos;
    if (Pos>strlen (Where)-1)
      i=strlen (Where)-1;
    else
      i--;
    while (i>0 && strrchr (Spaces,Where[i])!=NULL)
      i--;
    while (i>0 && strrchr (Spaces,Where[i])==NULL)
      i--;
    if (i>0) i++;
    return (Pos-i);
  }
  else return (0);
} /* prev_word */

//--------------------------- min  -----------------------------------------
long min (long A, long B){
  return (A<B?A:B);
} /* min */
//--------------------------- max  -----------------------------------------
long max (long A, long B){
  return (A>B?A:B);
} /* max */
//--------------------------- compare  -----------------------------------------
int compare (string Str1, string Str2) {
  uint i,N1=strlen (Str1);
  uint N2=strlen (Str2);
  if (N1>N2) return (FALSE);
  for(i=0; i<N1; i++)
    if (Str1[i]!=Str2[i]) return (FALSE);
  return (TRUE);
} /* compare */
//--------------------------- in_spaces  -----------------------------------------
boolean in_spaces (char Z) {
  if (strrchr (Spaces,Z)==NULL)
    return (FALSE);
  else
    return (TRUE);
} /* in_spaces */
//--------------------------- read_word  -----------------------------------------
boolean read_word (string Where, uint Pos, string &Word) {
  // predpoklada, ze prvni znak neni oddelovac
  uint N=strlen (Where);
  if (Pos>=N || in_spaces (Where[Pos])) return (FALSE);
  uint Beg=Pos;
  while (Pos<N && (!in_spaces(Where[Pos]))){
    Word[Pos-Beg]=Where[Pos];
    Pos++;
  }
  Word[Pos-Beg]='\0';
  return (TRUE);
} /* read_word */
//--------------------------- mid_write  -----------------------------------------
void mid_write (string Str, uint Beg, uint End) {
  uint N=strlen (Str);
  if (Beg<=End && End<N){
    for(uint i=Beg; i<=End; i++)
      cprintf ("%c",Str[i]);
  }
} /* mid_write */

