#include"syntax.h"
#include<conio.h>

//=========================== TStringList ===================================
//--------------------------- TStringList:TStringList  ----------------------
TStringList::TStringList () {
  Head=NULL,
  Tail=NULL;
  Count=0;
} /* TStringList:TStringList */

//--------------------------- TStringList::new_item  -----------------------------------------
TListItem* TStringList::new_item (string Value) {
  TListItem *Pom;
  string _Value;

  // alokuje se misto pro novou polozku
  if ((Pom=(TListItem*)malloc(sizeof (TListItem)))==NULL)
    printf ("Malo pameti pro novou polozku seznamu (TStringList)");
  // alokace mista pro retezec
  _Value=new_str_cpy (Value);


  Pom->Value=_Value;
  Pom->Next=NULL;
  return (Pom);
} /* TStringList::new_item */

//--------------------------- TStringList::add  -----------------------------------------
void TStringList::add (string Value) {
  TListItem *Pom=new_item (Value);

  if (Head==NULL && Tail==NULL) {
    Head=Pom;
    Tail=Pom;
  }
  else {
    Tail->Next=Pom;
    Tail=Pom;
  }
  Count++;
} /* TStringList::add */

//--------------------------- TStringList::clear  -----------------------------------------
void TStringList::clear () {
  TListItem *Pom;

  while (Head!=NULL){
    Pom=Head;
    Head=Pom->Next;
    free (Pom->Value);
    free (Pom);
  }

  Tail=NULL;
  Count=0;
} /* TStringList::clear */

//--------------------------- TStringList::print  -----------------------------------------
void TStringList::print () {
  TListItem *Pom;

  Pom=Head;
  while (Pom!=NULL){
    printf ("\n%s",Pom->Value);
    Pom=Pom->Next;
  }

} /* TStringList::print */

//--------------------------- TStringList::item  -----------------------------------------
string TStringList::item (int ItemIndex) {
  if (ItemIndex<Count) {
    TListItem *Pom=Head;

    for(int i=0; i<ItemIndex; i++)
      Pom=Pom->Next;
    return (Pom->Value);
  }
  else
    return (NULL);
} /* TStringList::item */
//--------------------------- TStringList::p_item  -----------------------------------------
TListItem* TStringList::p_item (int ItemIndex) {

  if (ItemIndex<Count) {
    TListItem *Pom=Head;

    for(int i=0; i<ItemIndex; i++)
      Pom=Pom->Next;
    return (Pom);
  }
  else
    return (NULL);
} /* TStringList::p_item */

//--------------------------- TStringList::p_exchange  -----------------------------------------
void TStringList::p_exchange (TListItem* Item1, TListItem* Item2) {
  if (Item1!=NULL && Item2!=NULL){
    string Pom=Item1->Value;
    Item1->Value=Item2->Value;
    Item2->Value=Pom;
  }
} /* TStringList::p_exchange */


//--------------------------- TStringList::exchange  -----------------------------------------
void TStringList::exchange (int ItemIndex1, int ItemIndex2){
  if (ItemIndex1!=ItemIndex2){
    TListItem *Item1=p_item (ItemIndex1),
	      *Item2=p_item (ItemIndex2);
    p_exchange (Item1, Item2);
  }
} /* TStringList::exchange */

//--------------------------- TStringList::insert  -----------------------------------------
void TStringList::insert (int ItemIndex, string Value) {
  TListItem *New=new_item (Value),
	    *Pom;

  if (ItemIndex>Count) ItemIndex=Count;
  if (ItemIndex){
    Pom=p_item (ItemIndex-1);
    New->Next=Pom->Next;
    Pom->Next=New;
  }
  else{
    New->Next=Head;
    Head=New;
  }
  Count++;

} /* TStringList::insert */
//--------------------------- TStringList::remove  -----------------------------------------
void TStringList::remove (int ItemIndex) {
  if (ItemIndex<Count) {
    if (ItemIndex){
      TListItem *Pom=p_item (ItemIndex-1);
      TListItem *Kill=Pom->Next;
      Pom->Next=Kill->Next;
      free (Kill->Value);
      free (Kill);
    }
    else{
      TListItem *Kill=Head;
      Head=Head->Next;
      free (Kill->Value);
      free (Kill);
    }
    Count--;
  }

} /* TStringList::remove */


//--------------------------- TStringList::sort  -----------------------------------------
void TStringList::sort () {
  if (Count>1) {
    boolean Change;
    int i;
    TListItem *Item1, *Item2;

    do {
      Change=FALSE;
      Item2=Head;
      Item1=Head->Next;

      for(i=0; i<Count-1; i++){
	if (strcmp(Item1->Value,Item2->Value)<0) {
	  p_exchange (Item1,Item2);
	  Change=TRUE;
	}
	Item2=Item1;
	Item1=Item1->Next;
	}

    } while (Change);
  } // Count>1
} /* TStringList::sort */

//--------------------------- TStringList::to_top  -----------------------------------------
void TStringList::to_top (uint ItemIndex) {
  if (ItemIndex>0){
    TListItem *Pom=p_item (ItemIndex-1);
    TListItem *First=Pom->Next;
    Pom->Next=First->Next;
    First->Next=Head;
    //Head->Next=First;
    Head=First;
  }
} /* TStringList::to_top */
//--------------------------------------------------------------------------
/*

//-------------------------- game_over  --------------------------------------
void game_over(string Message){
  clrscr();
  printf ("\nERROR: %s",Message);
  exit(0);
}/* */






//--------------------------- TSyntaxTable::TSyntaxTable  -----------------------------------------
TSyntaxTable::TSyntaxTable (string FileName) {
  // inicialisace ... naalokovani pole pro tabulku
  ArrayOfS=(TStringList **) malloc (16*sizeof(TStringList*));
  // inicialisace polozek tabulky
  for(uint i=0; i<16; i++)
    ArrayOfS[i]=new TStringList();
  // pripadne nahrati tabulky
  if (FileName!=NULL) load (FileName);
} /* TSyntaxTable::TSyntaxTable */

//--------------------------- TSyntaxTable::~TSyntaxTable  -----------------------------------------
TSyntaxTable::~TSyntaxTable () {
  for(uint i=0; i<16; i++)
    delete (ArrayOfS[i]);
  free (ArrayOfS);
} /* TSyntaxTable::~TSyntaxTable */

//--------------------------- TSyntaxTable::clear  -----------------------------------------
void TSyntaxTable::clear () {
  // vymazani obsahu tabulek
  for(uint i=0; i<16; i++){
    ArrayOfS[i]->clear();
  }
} /* TSyntaxTable::clear */

//--------------------------- TSyntaxTable::print  -----------------------------------------
void TSyntaxTable::print () {
  // pomocny vypis tabulek
  for(uint i=0; i<16; i++){
    printf ("\n%d--------------------",i);
    ArrayOfS[i]->print ();
  }
} /* TSyntaxTable::print */

//--------------------------- TSyntaxTable::load  -----------------------------------------
int TSyntaxTable::load (string FileName) {
  // hlavni procedura - nacteni tabulek ze souboru
  // Navratove hodnoty:
  // -1....nepodarilo se otevrit soubor
  // -2....malo pameti
  // -3....spatna struktura

  FILE *F;
  string Line;
  char Str[5];
  string Pom=Str;
  uint Color;
  uint Count;
  uint i;
  int Result=0;


  if ((F=fopen (FileName, "rt"))!=NULL){
    clear();
    while ((Result=read_line (F,Line))==0&&(Line!=NULL)){
    // nacitani radku
      if (!read_word (Line,0,Pom)){
	clear();return (-3);}

      Color=strtol (Pom,0,0);
      if (!read_word (&Line[strlen (Pom)+1],0,Pom)){clear();return (-3);}

      Count=strtol (Pom,0,0);

      for(i=0; i<Count; i++){
	Result=read_line (F,Line);
	if (Result){clear();return (-2);}
	if (Line==NULL){clear();return (-3);}
	if (Line[strlen (Line)-1]=='\n')
	  Line[strlen (Line)-1]='\0';
	ArrayOfS[Color]->add (Line);
        free (Line);
      } // end of for
    } // end of while
    if (Result==-1){
      clear();
      return (-2);
    }
  } // end of if
  else
    return (-1);

  return (0);
} /* TSyntaxTable::load */

//--------------------------- TSyntaxTable::search_str  -----------------------------------------
int TSyntaxTable::search_str (string Str) {
  uint i,j;
  TStringList *Pom;
  TListItem *Item;
  for(i=0; i<16; i++){
    Pom=ArrayOfS[i];
    Item=Pom->Head;
    for(j=0; j<Pom->Count; j++){
      if (strcmp (Item->Value,Str)==0){
	// mirna optimalisace (co se pouziva se soupne nahoru)
	Pom->to_top (j);
	return (i);
      }
      Item=Item->Next;
    }
  }
  return (14);
} /* TSyntaxTable::search_str */
//--------------------------- TSyntaxTable::search_ch  -----------------------------------------
int TSyntaxTable::search_ch (char Z) {
  uint i,j;
  TStringList *Pom;
  TListItem *Item;
  for(i=0; i<16; i++){
    Pom=ArrayOfS[i];
    Item=Pom->Head;
    for(j=0; j<Pom->Count; j++){
      if (strchr (Item->Value,Z)!=NULL) return (i);
      Item=Item->Next;
    }
  }
  return (14);
} /* TSyntaxTable::search_ch */

//--------------------------- TSyntaxTable::my_cprint  -----------------------------------------
void TSyntaxTable::my_cprint (string Str, uint Beg, uint End) {
// Str....string, co se ma vytisknout
// Beg....prvni tistene pismeno
// End....posledni tistene pismeno
  End=min (strlen (Str),End);
  uint A;
  uint Length;
  int Pos=Beg;
  uint NW;
  char W[100]="";
  string Word=W;
//  uint Eow;
  if (!(in_spaces (Str[Pos]))){   // Prvni slovo
    while (Pos>=0 && !in_spaces (Str[Pos])) Pos--;
    Pos++;
  }

  while (Pos<=End){
    if (in_spaces (Str[Pos])){  // write_normal_char
      textcolor (search_ch (Str[Pos]));
      cprintf ("%c",Str[Pos]);
      Pos++;
    }
    else {  // slovo
      read_word (Str,Pos,Word);
      textcolor (search_str (Word));
      NW=strlen (W);
      if (Pos<Beg || Pos+NW-1>End){
       //	if (Pos<Beg) NW=NW-(Beg-Pos);
       //	mid_write (Str,max(Pos,Beg),min (End,Pos+NW-1));
	if (Pos<Beg) Length=NW-(Beg-Pos);
	else Length=NW;
	if (Pos+NW-1>End) Length=Length-(Pos-1+NW-End);
	mid_write (Str,max(Pos,Beg),max(Pos,Beg)+Length-1);


      }
      else cprintf ("%s",Word);
      Pos=Pos+NW;
    }
  }
} /* TSyntaxTable::my_cprint */

//===========================  HLAVNI PROGRAM  ===============================

/*
void main () {
  textbackground (1);
  clrscr();
  TSyntaxTable *ST=new TSyntaxTable();
  cprintf ("---%d--", ST->load ("TABLE.INI"));
  ST->print ();
//  clrscr();
  for(uint i=0; i<50; i++){
    //gotoxy (0,i+1);
    //printf ("\n");
     clrscr();
    ST->my_cprint ("#define (if) then ... , <> kill endif",i,17);
    getch();

  }
}
*/