#include<stdio.h>
#include"types.h"
#include"editor.h"
#include"string.h"
#ifndef _SYNTAX_
  #define _SYNTAX_

  #ifndef _TYPES_
    #include "types.h"
  #endif

  #ifndef _STRING_
    #include "string.h"
  #endif


//--------------------------- TStringList -----------------------------------------
typedef struct SListItem TListItem;
struct SListItem {
  string Value;
  struct SListItem *Next;
};


class TStringList {
  public:
    TListItem *Head, *Tail;
    int Count;
    TStringList();                        // vytvori prazdny seznam

    ~TStringList(){clear();};
    TListItem* new_item (string Value);   // Vytvori novou polozku
    void add (string Value);              // prida na konec dalsi polozku
    void clear ();                        // vymaze seznam -> uvolni pamet
    string item (int ItemIndex);
    TListItem* p_item (int ItemIndex);
    void exchange (int ItemIndex1, int ItemIndex2); // prehodi dve polozky
    void p_exchange (TListItem* Item1, TListItem* Item2);
    void insert(int ItemIndex, string Value);// vlozi na posici Pos novou polozku
    void remove (int ItemIndex);          // vybere a zrusi jednu polozku
    void remove (TListItem* Item);
    void sort ();                         // setridi seznam
    void print();                         // vytiskne seznam
    long get_count() {return (Count);};
    void to_top (uint ItemIndex);
};

//--------------------------------------------------------------------------


class TSyntaxTable {
  private:
    uint SCount;
    TStringList **ArrayOfS;
  public:
    TSyntaxTable(string FileName=NULL);
    ~TSyntaxTable ();
    int load (string FileName);
    void clear();
    void print();
    int search_str (string Str);
    int search_ch (char Z);
    void my_cprint (string Str, uint Beg, uint End);
};

#endif